// 
//   Copyright (C) 2005, 2006, 2007 Free Software Foundation, Inc.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

///
///
/// create a dummy class to play with colors
///
///
///

function ColorMaker()
{
	this.colors = ["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];
}

o = ColorMaker.prototype;
	
o.createRandColor = function()
{
	var color="";
	var digit = [];
	for (var i=0;i<6;i++)
	{
		digit[i]=this.colors[Math.round(Math.random()*14)];
		color += digit[i];
	};
	return color;
};

o.createRandGrey = function()
{
	color="";
	
	var digit = this.colors[Math.round(Math.random()*14)];
	for (var i=0;i<6;i++)
	{
		
		color += digit;
	};	
	return color;
};

// Convert HSL value to an RGB color
//
// See http://en.wikipedia.org/wiki/HSV_color_space#Conversion_from_HSL_to_RGB
//
ColorMaker.HSLtoRGB = function(H, L, S)
{

	var q = L < 0.5 ? L*(1+S) : L+S-(L*S);
	var p = 2*L - q;
	var Hk = H/360; // H normalized to be in the range [0,1)

	var Tr = Hk+(1/3);
	var Tg = Hk;
	var Tb = Hk-(1/3);

	var C = new Array(3);
	C[0] = Tr;
	C[1] = Tg;
	C[2] = Tb;

	for (var i=0; i<3; ++i)
	{
		if ( C[i] < 0 ) C[i] += 1;
		else if ( C[i] > 1 ) C[i] -= 1;

		if ( C[i] < 1/6 )
		{
			C[i] = p + ((q-p) * 6 * C[i]);
		}
		else if ( C[i] < 1/2 )
		{
			C[i] = q;
		}
		else if ( C[i] < 2/3 )
		{
			C[i] = p + ((q-p) * 6 * (2/3 - C[i]));
		}
		else
		{
			C[i] = p;
		}
	}

	var r = 255*C[0];
	var g = 255*C[1];
	var b = 255*C[2];
	var color = r<<16 | g<<8 | b;

	return color;
};

// Convert HSV value to an RGB color
//
// See http://en.wikipedia.org/wiki/HSV_color_space#Conversion_from_HSV_to_RGB
//
ColorMaker.HSVtoRGB = function(H, S, V)
{
	var Hi = (H/60) % 6;
	var f  = (H/60) - Hi;
	var p  = V * ( 1 - S );
	var q  = V * ( 1 - (f*S) );
	var t  = V * ( 1 - ((1-f)*S) );

	var r = 0;
	var g = 0;
	var b = 0;

	switch (Hi)
	{
		case 0:
			r=V; g=t; b=p;
			break;
		case 1:
			r=q; g=V; b=p;
			break;
		case 2:
			r=p; g=V; b=t;
			break;
		case 3:
			r=p; g=q; b=V;
			break;
		case 4:
			r=t; g=t; b=V;
			break;
		case 5:
			r=V; g=p; b=q;
			break;
	}

	r *= 255;
	g *= 255;
	b *= 255;

	//trace("R:"+r+" G:"+g+" B:"+b);

	var color = r<<16 | g<<8 | b;

	return color;
};

delete o;
