// 
//   Copyright (C) 2005, 2006, 2007 Free Software Foundation, Inc.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

#include "OutputGrid.as"
#include "InputGrid.as"
#include "ColorMaker.as"

COLS = 20;
ROWS = 20;

myColorMaker = new colorMaker();
outputGrid = createOutputGrid(_root, 'outputGrid', 1, COLS, ROWS, 20, 20);

inputGrid = createInputGrid(_root, 'inputGrid', 2, outputGrid); 
inputGrid._x = (outputGrid.cols*outputGrid.cellWidth) + 10; 

// HUE values:
//	  0: red 
//	 60: yellow 
//	120: green
//	240: blu
//
outputGrid.setHue(240);


for(var i=0; i<inputGrid.rows; i++)
{
	for(var j=0; j<inputGrid.cols; j++)
	{
		var f = (j*(i+1))/(outputGrid.cols*outputGrid.rows); 
		var intensity = Math.floor(9*f+1);
		inputGrid.setCellValue(i, j, intensity);
	}
}	

outputGrid.setHue(0);
outputGrid.updateColors(inputGrid);

hueControl = createEmptyMovieClip("hueControl", 3);
hueControl.outputGrid = outputGrid;
hueControl.inputGrid = inputGrid;
with (hueControl)
{

	red = createEmptyMovieClip("red", 1);
	outputGrid.drawRect(red, 20, 20, 0xFF0000);
	red._x = 0;
	red.onRollOver = function() {}; // just to get an hand cursor

	yellow = createEmptyMovieClip("yellow", 2);
	outputGrid.drawRect(yellow, 20, 20, 0xFFFF00);
	yellow._x = 50;
	yellow.onRollOver = function() {}; // just to get an hand cursor

	blu = createEmptyMovieClip("blu", 3);
	outputGrid.drawRect(blu, 20, 20, 0x0000FF);
	blu._x = 100;
	blu.onRollOver = function() {}; // just to get an hand cursor

	onMouseUp = function()
	{
		var x = this._xmouse;
		var y = this._ymouse;

		var redBounds = red.getBounds(_root);
		var yellowBounds = yellow.getBounds(_root);
		var bluBounds = blu.getBounds(_root);
		trace(" red bounds are "+redBounds.xMin+","+redBounds.yMin+" "+redBounds.xMax+","+redBounds.yMax);
		trace(" yellow bounds are "+yellowBounds.xMin+","+yellowBounds.yMin+" "+yellowBounds.xMax+","+yellowBounds.yMax);
		trace(" blu bounds are "+bluBounds.xMin+","+bluBounds.yMin+" "+bluBounds.xMax+","+bluBounds.yMax);

		if ( red.hitTest(x, y) )
		{
			trace("Mouse on: x:"+x+" y:"+y+" hits red");
			outputGrid.setHue(0);
			outputGrid.updateColors(inputGrid);
		}
		else if ( yellow.hitTest(x, y) )
		{
			trace("Mouse on: x:"+x+" y:"+y+" hits yellow");
			outputGrid.setHue(60);
			outputGrid.updateColors(inputGrid);
		}
		else if ( blu.hitTest(x, y) )
		{
			trace("Mouse on: x:"+x+" y:"+y+" hits blu");
			outputGrid.setHue(240);
			outputgrid.updatecolors(inputgrid);
		}
		else
		{
			trace("Mouse on: x:"+x+" y:"+y+" hits nothing");
		}
	};

}
hueControl._y = outputGrid._height + 10;
hueControl._x = outputGrid._x + (outputGrid._width/2) - (hueControl._width/2);
